import uuid

from barker.models.meta import Base
from sqlalchemy import Boolean, Column, Integer, Unicode, text
from sqlalchemy.dialects.postgresql import UUID


class MenuCategory(Base):
    __tablename__ = "menu_categories"

    id = Column(
        "id", UUID(as_uuid=True), primary_key=True, server_default=text("gen_random_uuid()"), default=uuid.uuid4
    )
    name = Column("name", Unicode(255), nullable=False, unique=True)

    is_active = Column("is_active", Boolean, nullable=False)
    is_fixture = Column("is_fixture", Boolean, nullable=False)
    sort_order = Column("sort_order", Integer, nullable=False)

    def __init__(self, name, is_active, sort_order, is_fixture=False, id_=None):
        self.name = name
        self.is_active = is_active
        self.sort_order = sort_order
        self.is_fixture = is_fixture
        self.id = id_
