import uuid

from barker.models.meta import Base
from sqlalchemy import Column, Unicode, text
from sqlalchemy.dialects.postgresql import UUID


class Printer(Base):
    __tablename__ = "printers"

    id = Column(
        "id", UUID(as_uuid=True), primary_key=True, server_default=text("gen_random_uuid()"), default=uuid.uuid4
    )
    name = Column("name", Unicode(255), unique=True, nullable=False)
    address = Column("address", Unicode(255), nullable=False)
    cut_code = Column("cut_code", Unicode(255), nullable=False)

    def __init__(self, name=None, address=None, cut_code=None, id_=None):
        self.id = id_
        self.name = name
        self.address = address
        self.cut_code = cut_code
