import uuid

from barker.models.meta import Base
from sqlalchemy import Column, ForeignKey, Table, UniqueConstraint, text
from sqlalchemy.dialects.postgresql import UUID


role_permissions = Table(
    "role_permissions",
    Base.metadata,
    Column("id", UUID(as_uuid=True), primary_key=True, server_default=text("gen_random_uuid()"), default=uuid.uuid4),
    Column(
        "permission_id",
        UUID(as_uuid=True),
        ForeignKey("permissions.id"),
        nullable=False,
    ),
    Column("role_id", UUID(as_uuid=True), ForeignKey("roles.id"), nullable=False),
    UniqueConstraint("permission_id", "role_id"),
)
