import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot, Resolve } from '@angular/router';
import { Observable } from 'rxjs';

import { CashierReport } from './cashier-report';
import { CashierReportService } from './cashier-report.service';

@Injectable({
  providedIn: 'root',
})
export class CashierReportResolver implements Resolve<CashierReport> {
  constructor(private ser: CashierReportService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<CashierReport> {
    const id = route.paramMap.get('id');
    const startDate = route.queryParamMap.get('startDate') || null;
    const finishDate = route.queryParamMap.get('finishDate') || null;
    return this.ser.list(id, startDate, finishDate);
  }
}
