import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';

import { Device } from '../../core/device';

import { DeviceListDataSource } from './device-list-datasource';

@Component({
  selector: 'app-device-list',
  templateUrl: './device-list.component.html',
  styleUrls: ['./device-list.component.css'],
})
export class DeviceListComponent implements OnInit {
  list: Device[] = [];
  dataSource: DeviceListDataSource = new DeviceListDataSource(this.list);
  /** Columns displayed in the table. Columns IDs can be added, removed, or reordered. */
  displayedColumns = ['name', 'section', 'enabled', 'creationDate', 'last'];

  constructor(private route: ActivatedRoute) {}

  ngOnInit() {
    this.route.data.subscribe((value) => {
      const data = value as { list: Device[] };
      this.list = data.list;
    });
    this.dataSource = new DeviceListDataSource(this.list);
  }
}
