import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { GuestBookDetailResolver } from './guest-book-detail-resolver.service';
import { GuestBookDetailComponent } from './guest-book-detail/guest-book-detail.component';
import { GuestBookListResolver } from './guest-book-list-resolver.service';
import { GuestBookListComponent } from './guest-book-list/guest-book-list.component';

const routes: Routes = [
  {
    path: '',
    component: GuestBookListComponent,
    canActivate: [AuthGuard],
    data: {
      permission: 'Customers',
    },
    resolve: {
      list: GuestBookListResolver,
    },
    runGuardsAndResolvers: 'always',
  },
  {
    path: 'new',
    component: GuestBookDetailComponent,
    canActivate: [AuthGuard],
    data: {
      permission: 'Customers',
    },
    resolve: {
      item: GuestBookDetailResolver,
    },
  },
  {
    path: ':id',
    component: GuestBookDetailComponent,
    canActivate: [AuthGuard],
    data: {
      permission: 'Customers',
    },
    resolve: {
      item: GuestBookDetailResolver,
    },
  },
];

@NgModule({
  declarations: [],
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
  providers: [GuestBookListResolver, GuestBookDetailResolver],
})
export class GuestBookRoutingModule {}
