import { CdkTableModule } from '@angular/cdk/table';
import { CdkTreeModule } from '@angular/cdk/tree';
import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { FlexLayoutModule } from '@angular/flex-layout';
import { ReactiveFormsModule } from '@angular/forms';
import { MatButtonModule } from '@angular/material/button';
import { MatCardModule } from '@angular/material/card';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatDividerModule } from '@angular/material/divider';
import { MatIconModule } from '@angular/material/icon';
import { MatInputModule } from '@angular/material/input';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { MatTableModule } from '@angular/material/table';
import { MatTreeModule } from '@angular/material/tree';

import { SharedModule } from '../shared/shared.module';

import { ModifierCategoriesRoutingModule } from './modifier-categories-routing.module';
import { ModifierCategoryDetailComponent } from './modifier-category-detail/modifier-category-detail.component';
import { ModifierCategoryListComponent } from './modifier-category-list/modifier-category-list.component';

@NgModule({
  imports: [
    CommonModule,
    CdkTableModule,
    CdkTreeModule,
    FlexLayoutModule,
    MatButtonModule,
    MatCardModule,
    MatCheckboxModule,
    MatDividerModule,
    MatIconModule,
    MatInputModule,
    MatProgressSpinnerModule,
    MatTableModule,
    MatTreeModule,
    ReactiveFormsModule,
    SharedModule,
    ModifierCategoriesRoutingModule,
  ],
  declarations: [ModifierCategoryListComponent, ModifierCategoryDetailComponent],
})
export class ModifierCategoriesModule {}
