import { Component, Inject } from '@angular/core';
import { FormArray, FormBuilder, FormGroup } from '@angular/forms';
import { MAT_DIALOG_DATA, MatDialogRef } from '@angular/material/dialog';
import { Observable } from 'rxjs';

@Component({
  selector: 'app-split-bill',
  templateUrl: './split-bill.component.html',
  styleUrls: ['./split-bill.component.css'],
})
export class SplitBillComponent {
  list: { id: string; name: string; selected: boolean }[] = [];
  form: FormGroup;

  constructor(
    public dialogRef: MatDialogRef<SplitBillComponent>,
    private fb: FormBuilder,
    @Inject(MAT_DIALOG_DATA)
    public data: Observable<{ id: string; name: string; selected: boolean }[]>,
  ) {
    this.form = this.fb.group({
      saleCategories: this.fb.array([]),
    });
    this.data.subscribe((list: { id: string; name: string; selected: boolean }[]) => {
      this.list = list;
      this.form.setControl(
        'saleCategories',
        this.fb.array(
          this.list.map((x) =>
            this.fb.group({
              saleCategory: x.selected,
            }),
          ),
        ),
      );
    });
  }

  accept(): void {
    const array = this.form.get('saleCategories') as FormArray;
    this.list.forEach((item, index) => {
      item.selected = array.controls[index].value.saleCategory;
    });
    this.dialogRef.close(this.list);
  }
}
