import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot, Resolve } from '@angular/router';
import { Observable } from 'rxjs';

import { SectionPrinter } from '../core/section-printer';

import { SectionPrinterService } from './section-printer.service';

@Injectable({
  providedIn: 'root',
})
export class SectionPrinterResolver implements Resolve<SectionPrinter[]> {
  constructor(private ser: SectionPrinterService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<SectionPrinter[]> {
    const id = route.paramMap.get('id');
    return this.ser.get(id);
  }
}
