import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';

import { Tax } from '../../core/tax';

import { TaxListDataSource } from './tax-list-datasource';

@Component({
  selector: 'app-tax-list',
  templateUrl: './tax-list.component.html',
  styleUrls: ['./tax-list.component.css'],
})
export class TaxListComponent implements OnInit {
  list: Tax[] = [];
  dataSource: TaxListDataSource = new TaxListDataSource(this.list);
  /** Columns displayed in the table. Columns IDs can be added, removed, or reordered. */
  displayedColumns = ['name', 'rate', 'isFixture'];

  constructor(private route: ActivatedRoute) {}

  ngOnInit() {
    this.route.data.subscribe((value) => {
      const data = value as { list: Tax[] };
      this.list = data.list;
    });
    this.dataSource = new TaxListDataSource(this.list);
  }
}
